#ifndef __FTPDATACONNECTION__
#define __FTPDATACONNECTION__

#include <qobject.h>
#include <qsocketdevice.h>
#include <qthread.h>
#include <qiodevice.h>
#include <qstring.h>

#define BLOCK_SIZE 512

enum Mode { Stream, Block, Compressed };
enum Type { ASCII, EBCDIC, Image };

class FTPDataConnection : public QObject, public QThread
{
	Q_OBJECT

	private:
		QSocketDevice *socket;
		QIODevice *device;
		
		Mode mode;
		Type type;
		bool send;

	public:
		FTPDataConnection();
		~FTPDataConnection();

		void set_iodevice(QIODevice *d);
		bool establish_connection(const QString &s, Q_INT16 port);
		bool establish_connection(Q_INT16 port);

		void set_mode(Mode m);
		void set_type(Type t);
		void set_direction(bool s);

		bool is_open();
		
		void run();

		void recv_data();
		void send_data();

	signals:
		void transfer_complete();
};

#endif // __FTPDATACONNECTION
