#include "FTPRequestReplySocket.h"
#include <iostream>
using namespace std;

FTPRequestReplySocket::FTPRequestReplySocket()
{
	socket = NULL;
}

FTPRequestReplySocket::~FTPRequestReplySocket()
{
	if(socket != NULL)
		delete socket;
}

bool FTPRequestReplySocket::connect(const QString &host, Q_UINT16 port)
{
	QHostAddress addr;
	if(!addr.setAddress(host))
	{
		return false;
	}
	socket = new QSocketDevice();
	return socket->connect(addr, port);
}

void FTPRequestReplySocket::send_message(const QString &msg)
{
	socket->writeBlock(msg.latin1(), msg.length());
	socket->writeBlock("\r\n", 2);
	socket->flush();
}

QString FTPRequestReplySocket::recv_message()
{
	QString reply = "";
	QString tmp;
	QString multiline = "";
	while(1)
	{
		tmp = read_line();
		reply += tmp;
		if(tmp[3] == '-')
			continue;

		break;
	}

	return reply;
}

QString FTPRequestReplySocket::read_line()
{
	char c;
	QString msg = "";
	while(1)
	{
		if(socket->readBlock(&c, 1) == 1)
		{
			msg += c;
			if(msg.endsWith("\r\n"))
			{
				msg.truncate(msg.length()-2);
				return msg;
			}
		}
	}
}
