#include "FilePanel.h"
#include "FilePanelItem.h"
#include <qstringlist.h>
#include <qobject.h>

#include <iostream>
using namespace std;

FilePanel::FilePanel(QWidget *par, FTPConnection *ftp)
	: QListView(par)
{
	connection = ftp;
	
	setRootIsDecorated(true);
	setSorting(0);
	addColumn("Entry");
	addColumn("Type");

	connect(this, SIGNAL(selectionChanged(QListViewItem *)),
			this, SLOT(dir_refresh(QListViewItem *)));
	connect(this, SIGNAL(doubleClicked(QListViewItem *)),
			this, SLOT(download(QListViewItem *)));

	new FilePanelItem(this, true, "/", "/");
}

void FilePanel::dir_refresh(QListViewItem *i)
{
	cout << "REFRESH" << endl;
	if(i == NULL)
		return;
cout << "not null" << endl;
	FilePanelItem *item = (FilePanelItem*)i;
	if(!item->is_dir())
		return;
cout << "is dir" << endl;
	if(item->get_children())
		return;
cout << "has no children" << endl;
	QString path = item->get_path();
	connection->change_directory(path);
	QStringList list = connection->dir_list(true);
	QStringList tmp;

	item->children_read();
	
	QStringList::const_iterator iter;
	for(iter = list.begin(); iter != list.end(); ++iter)
	{
		tmp = QStringList::split(' ', *iter);
		if(tmp[8] == "." || tmp[8] == "..")
			continue;

		if(tmp[0][0] == 'd')
			new FilePanelItem(item, true, path + tmp[8], tmp[8]);
		else
			new FilePanelItem(item, false, path, tmp[8]);
	}

	triggerUpdate();
}

void FilePanel::download(QListViewItem *i)
{
	cout << "DOWNLOAD" << endl;
	if(i == NULL)
		return;

	FilePanelItem *item = (FilePanelItem*)i;
	if(item->is_dir())
		return;

	connection->change_directory(item->get_path());
	connection->get_file(item->get_name());
}
