#include "HistoryPanel.h"

HistoryPanel::HistoryPanel(QWidget *par, FTPConnection *ftp)
	: QTextEdit(par)
{
	setReadOnly(true);

	connect(ftp, SIGNAL(server_message(const QString &)),
			this, SLOT(server_message(const QString &)));
	connect(ftp, SIGNAL(command_message(const QString &)),
			this, SLOT(command_message(const QString &)));
	connect(ftp, SIGNAL(status_message(const QString &)),
			this, SLOT(status_message(const QString &)));
	connect(ftp, SIGNAL(error(const QString &)),
			this, SLOT(error(const QString &)));
}

void HistoryPanel::server_message(const QString &msg)
{
	QColor green(0,200,0);
	setColor(green);
	append(msg);
}

void HistoryPanel::command_message(const QString &msg)
{
	QColor blue(0,0,255);
	setColor(blue);
	append(msg);
}

void HistoryPanel::status_message(const QString &msg)
{
	QColor black(0,0,0);
	setColor(black);
	append(msg);
}

void HistoryPanel::error(const QString &msg)
{
	QColor red(255,0,0);
	setColor(red);
	append(msg);
}

