#include <iostream>
using namespace std;
#include "FTPConnection.h"
#include <stdlib.h>
#include <qstringlist.h>
#include <qapplication.h>
#include <qvbox.h>

#include "FilePanel.h"
#include "HistoryPanel.h"
#include "ConnectDialog.h"

int main(int argc, char **argv)
{
	QApplication app(argc, argv);
	
	ConnectDialog con;
	con.show();
	app.setMainWidget(&con);
	app.exec();
	
	FTPConnection ftp;
	if(ftp.connect(con.get_address(), con.get_port(), con.get_user(), con.get_password()))
	{
		cout << "Test Connected." << endl;
	}
	else
	{
		cout << "Test connection failed." << endl;
	}
	ftp.set_passive();

	QVBox vbox;
	FilePanel fp(&vbox, &ftp);
	HistoryPanel hp(&vbox, &ftp);

	app.setMainWidget(&vbox);
	vbox.show();
	
/*
	ftp.change_directory("/");
	ftp.set_type_binary();
	ftp.set_passive();

	QStringList lst = ftp.dir_list(true);
	cout << "LENGTH: "<< lst.size() << endl;
	for(QStringList::Iterator it = lst.begin(); it != lst.end(); ++it)
	{
		cout << "LIST: " << *it << endl;
	}
	
	ftp.change_directory("goo");
	ftp.set_passive();
	QStringList list = ftp.dir_list(true);
	for(QStringList::Iterator it = list.begin(); it != list.end(); ++it)
	{
		cout << "LIST: " << *it << endl;
	}
	ftp.disconnect();
*/
	
	return app.exec();
}
